// TvRock DTV Target.
#include <windows.h>
#include <shlwapi.h>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT	// vOCNXƂĎ
#include "TVTestPlugin.h"
#include "TvRockDTV.h"

#pragma comment(lib,"shlwapi.lib")

using namespace TVTest;
using namespace TvRock;

#define _PLUGIN_NAME		L"TvRock DTV Target"
#define _TVTEST_SETTING		L"TVTest.ini"
#define _FILE_EXTENSION		L".ts"

struct FreqInfo {
	WORD Frequency;
	WORD TSID;
};

static const FreqInfo BSChannelList[] = {
	{11727,	0x4010},	// BS1/TS0 BS
	{11727,	0x4011},	// BS1/TS1 BS-TBS
	{11766,	0x4030},	// BS3/TS0 WOWOW
	{11766,	0x4031},	// BS3/TS1 BSWp
	{11880,	0x4090},	// BS9/TS0 BS11
	{11880,	0x4091},	// BS9/TS1 Star Channel HV
	{11880,	0x4092},	// BS9/TS2 TwellV
	{11958,	0x40D0},	// BS13/TS0 BSe
	{11958,	0x40D1},	// BS13/TS1 BStW
	{11996,	0x40F1},	// BS15/TS1 NHK BS1/2
	{11996,	0x40F2},	// BS15/TS2 NHK BS-hi
};

static const FreqInfo CSChannelList[] = {
	{12291,	0x6020},	// ND2 110CS #1
	{12331,	0x7040},	// ND4 110CS #2
	{12371,	0x7060},	// ND6 110CS #3
	{12411,	0x6080},	// ND8 110CS #4
	{12451,	0x60A0},	// ND10 110CS #5
	{12491,	0x70C0},	// ND12 110CS #6
	{12531,	0x70E0},	// ND14 110CS #7
	{12571,	0x7100},	// ND16 110CS #8
	{12611,	0x7120},	// ND18 110CS #9
	{12651,	0x7140},	// ND20 110CS #10
	{12691,	0x7160},	// ND22 110CS #11
	{12731,	0x7180},	// ND24 110CS #12
};


// `l
class CChannelSearch {
	CTVTestApp *m_pApp;
	bool m_fInitialized;
	int m_TerrestrialIndex;
	int m_BSIndex;
	int m_CSIndex;
	bool m_fTerraIndexSpecified;
	bool m_fBSIndexSpecified;
	bool m_fCSIndexSpecified;

	// `[jOԂ̃CfbNX̎擾
	void GetSpaceIndex() {
		if (m_fInitialized)
			return;

		int i;
		bool fFound;
		WCHAR szLog[256];
		ChannelInfo ChannelInfo;

		if (m_TerrestrialIndex>=0) {
			// nfWTSID0x7FXX
			fFound=true;
			if (!m_fTerraIndexSpecified
					&& (!m_pApp->GetChannelInfo(m_TerrestrialIndex,0,&ChannelInfo)
					|| (ChannelInfo.TransportStreamID&0xFF00)!=0x7F00)) {
				fFound=false;
				for (i=0;m_pApp->GetChannelInfo(i,0,&ChannelInfo);i++) {
					if ((ChannelInfo.TransportStreamID&0xFF00)==0x7F00) {
						m_TerrestrialIndex=i;
						fFound=true;
						break;
					}
				}
			}
			::wsprintfW(szLog,
						fFound?L"nfW̃CfbNX擾܂B(%d)":
							   L"nfW̃CfbNX擾ł܂B%d ɉ肵܂B",
						m_TerrestrialIndex);
			m_pApp->AddLog(szLog);
		}

		if (m_BSIndex>=0) {
			// BSNID4ATSID0x4XXX
			fFound=true;
			if (!m_fBSIndexSpecified
					&& (!m_pApp->GetChannelInfo(m_BSIndex,0,&ChannelInfo)
					|| ChannelInfo.NetworkID!=0x0004
					|| (ChannelInfo.TransportStreamID!=0
						&& (ChannelInfo.TransportStreamID&0xF000)!=0x4000))) {
				fFound=false;
				for (i=0;m_pApp->GetChannelInfo(i,0,&ChannelInfo);i++) {
					if (ChannelInfo.NetworkID==0x0004
							|| (ChannelInfo.TransportStreamID&0xF000)==0x4000) {
						m_BSIndex=i;
						fFound=true;
						break;
					}
				}
				if (!fFound) {
					TVTest::TuningSpaceInfo SpaceInfo;

					for (i=0;m_pApp->GetTuningSpaceInfo(i,&SpaceInfo);i++) {
						if (SpaceInfo.Space==TVTest::TUNINGSPACE_BS) {
							m_BSIndex=i;
							fFound=true;
							break;
						}
					}
				}
			}
			::wsprintfW(szLog,
						fFound?L"BS̃CfbNX擾܂B(%d)":
							   L"BS̃CfbNX擾ł܂B%d ɉ肵܂B",
						m_BSIndex);
			m_pApp->AddLog(szLog);
		}

		if (m_CSIndex>=0) {
			// CS1TSID0x6XXXACS2TSID0x7XXX(0x7FXX͒nfW)
			fFound=true;
			if (!m_fCSIndexSpecified
					&& (!m_pApp->GetChannelInfo(m_CSIndex,0,&ChannelInfo)
					|| (ChannelInfo.NetworkID!=0x0006
						&& ChannelInfo.NetworkID!=0x0007)
					|| (ChannelInfo.TransportStreamID!=0
						&& (ChannelInfo.TransportStreamID&0xF000)!=0x6000
						&& ((ChannelInfo.TransportStreamID&0xF000)!=0x7000
						|| (ChannelInfo.TransportStreamID&0xFF00)==0x7F00)))) {
				fFound=false;
				for (i=0;m_pApp->GetChannelInfo(i,0,&ChannelInfo);i++) {
					if (ChannelInfo.NetworkID==0x0006
						|| ChannelInfo.NetworkID==0x0007
						|| (ChannelInfo.TransportStreamID&0xF000)==0x6000
						|| ((ChannelInfo.TransportStreamID&0xF000)==0x7000
							&& (ChannelInfo.TransportStreamID&0xFF00)!=0x7F00)) {
						m_CSIndex=i;
						fFound=true;
						break;
					}
				}
				if (!fFound) {
					TVTest::TuningSpaceInfo SpaceInfo;

					for (i=0;m_pApp->GetTuningSpaceInfo(i,&SpaceInfo);i++) {
						if (SpaceInfo.Space==TVTest::TUNINGSPACE_110CS) {
							m_CSIndex=i;
							fFound=true;
							break;
						}
					}
				}
			}
			::wsprintfW(szLog,
						fFound?L"CS̃CfbNX擾܂B(%d)":
							   L"CS̃CfbNX擾ł܂B%d ɉ肵܂B",
						m_CSIndex);
			m_pApp->AddLog(szLog);
		}
		m_fInitialized=true;
	}

public:
	CChannelSearch(CTVTestApp *pApp)
		: m_fInitialized(false)
		, m_TerrestrialIndex(-1)
		, m_BSIndex(-1)
		, m_CSIndex(-1)
		, m_fTerraIndexSpecified(false)
		, m_fBSIndexSpecified(false)
		, m_fCSIndexSpecified(false)
	{
		m_pApp = pApp;
	}

	void Init(LPCTSTR pszIniFileName,LPCTSTR pszSectionName) {
		// ݒǂݍ
		m_TerrestrialIndex=GetPrivateProfileInt(pszSectionName,TEXT("TerrestrialIndex"),-1,pszIniFileName);
		m_fTerraIndexSpecified=m_TerrestrialIndex>=0;
		m_BSIndex=GetPrivateProfileInt(pszSectionName,TEXT("BSIndex"),-1,pszIniFileName);
		m_fBSIndexSpecified=m_BSIndex>=0;
		m_CSIndex=GetPrivateProfileInt(pszSectionName,TEXT("CSIndex"),-1,pszIniFileName);
		m_fCSIndexSpecified=m_CSIndex>=0;
	}

	void SetProperty(RockProperty *pProp) {
		const bool fUseTerrestrial=pProp->UseTS(),fUseBS=pProp->UseBS(),fUseCS=pProp->UseCS();
		int i = 0;

		if (fUseTerrestrial) {
			if (!m_fTerraIndexSpecified)
				m_TerrestrialIndex = i++;
			else
				i = m_TerrestrialIndex + 1;
		} else {
			m_TerrestrialIndex = -1;
		}
		if (fUseBS) {
			if (!m_fBSIndexSpecified)
				m_BSIndex = i++;
			else
				i = m_BSIndex + 1;
		} else {
			m_BSIndex = -1;
		}
		if (fUseCS) {
			if (!m_fCSIndexSpecified)
				m_CSIndex = i++;
		} else {
			m_CSIndex = -1;
		}
	}

	bool SetChannel(const DWORD dwChannel, const DWORD dwService) {
		if (!m_fInitialized)
			GetSpaceIndex();

		ChannelInfo ChannelInfo;
		DWORD dwOffset;

		dwOffset=0;
		if (m_TerrestrialIndex>=0) {
			if(dwChannel>=63) {
				m_TerrestrialIndex=1;
				dwOffset=50;
			}
			else {
				m_TerrestrialIndex=0;
			}
		}
		if (m_TerrestrialIndex>=0 && (dwChannel-dwOffset)<=63) {
			for (int i=0;m_pApp->GetChannelInfo(m_TerrestrialIndex,i,&ChannelInfo);i++) {
				if (ChannelInfo.Channel==(dwChannel-dwOffset)-13
						&& (dwService==0 || ChannelInfo.ServiceID==dwService))
					return m_pApp->SetChannel(m_TerrestrialIndex,i);
			}
			for (int i=0;m_pApp->GetChannelInfo(m_TerrestrialIndex,i,&ChannelInfo);i++) {
				if (ChannelInfo.Channel==(dwChannel-dwOffset)-13) {
					if (!m_pApp->SetChannel(m_TerrestrialIndex,i))
						return false;
					if (dwService!=0 && !m_pApp->SetService(dwService,true))
						return false;
					return true;
				}
			}
			if (dwService!=0) {
				for (int i=0;m_pApp->GetChannelInfo(m_TerrestrialIndex,i,&ChannelInfo);i++) {
					if (ChannelInfo.ServiceID==dwService)
						return m_pApp->SetChannel(m_TerrestrialIndex,i);
				}
			}
			goto NotFound;
		}
		if (m_BSIndex>=0) {
			WORD Frequency=(WORD)(dwChannel>>16),TSID=(WORD)(dwChannel&0xFFFF);

			for (int i=0;i<sizeof(BSChannelList)/sizeof(FreqInfo);i++) {
				if (BSChannelList[i].Frequency==Frequency
						&& (TSID==0 || BSChannelList[i].TSID==TSID)) {
					for (int j=0;m_pApp->GetChannelInfo(m_BSIndex,j,&ChannelInfo);j++) {
						if (ChannelInfo.Channel==i && ChannelInfo.ServiceID==dwService)
							return m_pApp->SetChannel(m_BSIndex,j);
					}
					for (int j=0;m_pApp->GetChannelInfo(m_BSIndex,j,&ChannelInfo);j++) {
						if (ChannelInfo.Channel==i)
							return m_pApp->SetChannel(m_BSIndex,j)
								&& m_pApp->SetService(dwService,true);
					}
					goto NotFound;
				}
			}
		}
		if (m_CSIndex>=0) {
			WORD Frequency=(WORD)(dwChannel>>16),TSID=(WORD)(dwChannel&0xFFFF);

			for (int i=0;i<sizeof(CSChannelList)/sizeof(FreqInfo);i++) {
				if (CSChannelList[i].Frequency==Frequency
						/*&& (TSID==0 || CSChannelList[i].TSID==TSID)*/) {
					for (int j=0;m_pApp->GetChannelInfo(m_CSIndex,j,&ChannelInfo);j++) {
						if (ChannelInfo.Channel==i && ChannelInfo.ServiceID==dwService)
							return m_pApp->SetChannel(m_CSIndex,j);
					}
					for (int j=0;m_pApp->GetChannelInfo(m_CSIndex,j,&ChannelInfo);j++) {
						if (ChannelInfo.Channel==i)
							return m_pApp->SetChannel(m_CSIndex,j)
								&& m_pApp->SetService(dwService,true);
					}
					goto NotFound;
				}
			}
		}
	NotFound:
		m_pApp->AddLog(L"Y`l܂B");
		return false;
	}

	DWORD GetChannel() {
		if (!m_fInitialized)
			GetSpaceIndex();

		TVTest::ChannelInfo ChannelInfo;
		if (!m_pApp->GetCurrentChannelInfo(&ChannelInfo))
			return 0;
		if (ChannelInfo.Space==m_TerrestrialIndex) {
			/*
			if (ChannelInfo.PhysicalChannel!=0)
				return ChannelInfo.PhysicalChannel;
			*/
			return (ChannelInfo.Channel+13);
		}
		if (ChannelInfo.Space == m_BSIndex) {
			if (ChannelInfo.Channel<sizeof(BSChannelList)/sizeof(FreqInfo))
				return (BSChannelList[ChannelInfo.Channel].Frequency<<16)|
						BSChannelList[ChannelInfo.Channel].TSID;
		}
		if (ChannelInfo.Space == m_CSIndex) {
			if (ChannelInfo.Channel<sizeof(CSChannelList)/sizeof(FreqInfo))
				return (CSChannelList[ChannelInfo.Channel].Frequency<<16)|
						CSChannelList[ChannelInfo.Channel].TSID;
		}
		return 0;
	}
};


// TvRock̗v󂯎NX
class CTvRockRequest : public RockRequest
{
	CTVTestApp *m_pApp;
	CChannelSearch *m_pChannel;

public:
	CTvRockRequest(CTVTestApp *pApp, CChannelSearch *pChannel) {
		m_pApp = pApp;
		m_pChannel = pChannel;
	}
	// AvI̗v
	void PowerOff() {
		m_pApp->AddLog(L"TvRockIv󂯂܂B");
		m_pApp->Close(TVTest::CLOSE_EXIT);
	}
	// `lύX̗v
	bool ChannelChange(const DWORD dwChannel, const DWORD dwService) {
		WCHAR szLog[256];
		::wsprintfW(szLog,L"TvRock`lύXv󂯂܂B(Ch %lu Sv %lu)",dwChannel,dwService);
		m_pApp->AddLog(szLog);

		return (m_pChannel ? m_pChannel->SetChannel(dwChannel, dwService) : false);
	}
	// ^Jn̗v
	bool RecordStart(LPWSTR lpFileName) {
		WCHAR szLog[MAX_PATH+256];
		::wsprintfW(szLog,L"TvRock^Jnv󂯂܂B(%s)",lpFileName);
		m_pApp->AddLog(szLog);

		RecordInfo RecordInfo;
		RecordInfo.Mask=RECORD_MASK_FILENAME;
		RecordInfo.Flags=0;
		RecordInfo.pszFileName = lpFileName;
		RecordInfo.StartTimeSpec=TVTest::RECORD_START_NOTSPECIFIED;
//		RecordInfo.StartTime.Delay=HIWORD(wParam)*1000;
		RecordInfo.StopTimeSpec=TVTest::RECORD_STOP_NOTSPECIFIED;
//		RecordInfo.StopTime.Duration=pThis->m_RecordTime*1000;
		return m_pApp->StartRecord(&RecordInfo);
	}
	// NCbN^Jn̗v (Rocko[̒ژ^̗v)
	bool QuickRecord(LPWSTR lpFileName) {
		WCHAR szLog[MAX_PATH+256];
		::wsprintfW(szLog,L"TvRockNCbN^Jnv󂯂܂B(%s)",lpFileName);
		m_pApp->AddLog(szLog);

		return RecordStart(lpFileName);
	}
	// ^~̗v
	bool RecordStop() {
		m_pApp->AddLog(L"TvRock^~v󂯂܂B");
		return m_pApp->StopRecord();
	}
	// Î~ۑ̗v
	void ScreenCapture() {
		//m_pApp->AddLog(L"TvRockÎ~ۑv󂯂܂B");
		m_pApp->SaveImage();
	}
	// IvV{^̗v
	void OnOption() {
		m_pApp->AddLog(L"TvRockIvV{^̗v󂯂܂B");
	}
	// rfIEBhEnh̗v (Rocko[E^bvEEBhETCYύX)
	HWND GetVideoHandle() {
		return m_pApp->GetAppWindow();
	}
	// ^[Qbg̎擾
	void CollectSetting() {
	}
	// bZ[W
	LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
		return 0;
	}
};


// NeBJZNV
class CCriticalLock
{
public:
	CCriticalLock();
	virtual ~CCriticalLock();
	void Lock(void);
	void Unlock(void);
	bool TryLock(DWORD TimeOut=0);
private:
	CRITICAL_SECTION m_CriticalSection;
};

CCriticalLock::CCriticalLock()
{
	::InitializeCriticalSection(&m_CriticalSection);
}

CCriticalLock::~CCriticalLock()
{
	::DeleteCriticalSection(&m_CriticalSection);
}

void CCriticalLock::Lock(void)
{
	::EnterCriticalSection(&m_CriticalSection);
}

void CCriticalLock::Unlock(void)
{
	::LeaveCriticalSection(&m_CriticalSection);
}

bool CCriticalLock::TryLock(DWORD TimeOut)
{
	bool bLocked=false;
	if (TimeOut==0) {
		if (::TryEnterCriticalSection(&m_CriticalSection))
			bLocked=true;
	} else {
		for (DWORD i=TimeOut;i>0;i--) {
			if (::TryEnterCriticalSection(&m_CriticalSection)) {
				bLocked=true;
				break;
			}
			Sleep(1);
		}
	}
	return bLocked;
}


// CTvRockDTVTarget (TVBridge蔲)
class CTvRockDTVTarget : public CTVTestPlugin
{
	enum {
		DEFAULT_BUFFER_LENGTH=20000UL,
		DEFAULT_SEND_BUFFER_LENGTH=256UL
	};
	static LRESULT CALLBACK EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData);
	static BOOL CALLBACK StreamCallback(BYTE *pData,void *pClientData);
	HINSTANCE m_hPlug;
	TvRockDTV *m_pTvRock;
	CTvRockRequest *m_pRequest;
	CChannelSearch *m_pChannel;
	int m_DeviceID;
	WCHAR m_szDriverName[MAX_PATH];

	CCriticalLock m_StreamLock;
	HANDLE m_hProcessTSEvent;
	SIZE_T m_StreamBufferLength;
	BYTE *m_pStreamBuffer;
	SIZE_T m_StreamSendBufferLength;
	HANDLE m_hStreamThread;
	volatile bool m_fStreamEnd;
	DWORD m_DropCount;
	SIZE_T m_StreamBufferUsed;
	SIZE_T m_StreamBufferPos;

	bool GetStream(BYTE *pBuffer,SIZE_T *pBufferLength);
	void PurgeStream();
	static DWORD WINAPI StreamThread(LPVOID lpParameter);
	bool InitializeTvRockDTV(LPCWSTR pszCommandLine);
	static int GetDeviceID(LPCWSTR pszCommandLine,LPWSTR pszDriverName);

public:
	CTvRockDTVTarget()
		: m_hPlug(NULL)
		, m_pTvRock(NULL)
		, m_pRequest(NULL)
		, m_pChannel(NULL)
		, m_DeviceID(-1)
		, m_hProcessTSEvent(NULL)
		, m_StreamBufferLength(DEFAULT_BUFFER_LENGTH)
		, m_pStreamBuffer(NULL)
		, m_StreamSendBufferLength(DEFAULT_SEND_BUFFER_LENGTH)
		, m_hStreamThread(NULL)
		, m_fStreamEnd(false)
		, m_DropCount(0)
		, m_StreamBufferUsed(0)
		, m_StreamBufferPos(0)
	{
		m_szDriverName[0]='\0';
	}

	// vOC̏
	bool GetPluginInfo(TVTest::PluginInfo *pInfo) {
		pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
		pInfo->Flags          = 0;
		pInfo->pszPluginName  = _PLUGIN_NAME;
		pInfo->pszCopyright   = L"Public Domain";
		pInfo->pszDescription = L"TvRock DTV Target";
		return true;
	}

	// 
	bool Initialize() {
		InitializeTvRockDTV(::GetCommandLineW());

		m_pApp->SetEventCallback(EventCallback,this);

		return true;
	}

	// I
	bool Finalize() {
		m_pApp->SetStreamCallback(STREAM_CALLBACK_REMOVE,StreamCallback);
		if (m_hStreamThread) {
			m_fStreamEnd=true;
			if (::WaitForSingleObject(m_hStreamThread,3000)==WAIT_TIMEOUT)
				::TerminateThread(m_hStreamThread,1);
			::CloseHandle(m_hStreamThread);
			m_hStreamThread=NULL;
		}
		if (m_hProcessTSEvent) {
			::CloseHandle(m_hProcessTSEvent);
			m_hProcessTSEvent=NULL;
		}
		if (m_pStreamBuffer) {
			delete [] m_pStreamBuffer;
			m_pStreamBuffer=NULL;
		}
		// TvRockDTVTargetp
		if (m_pTvRock) {
			m_pTvRock->Dispose();
			delete m_pTvRock;
			delete m_pRequest;
			m_pTvRock = NULL;
			m_pRequest = NULL;
			m_pApp->AddLog(L"TvRock DTV Target̏Is܂B");
		}
		if (m_hPlug) {
			::FreeLibrary(m_hPlug);
			m_hPlug=NULL;
		}
		if (m_pChannel) {
			delete m_pChannel;
			m_pChannel = NULL;
		}
		m_DeviceID=-1;
		m_szDriverName[0]='\0';
		return true;
	}

public:
	// TS
	void ProcessTS(BYTE *pData, const DWORD dwLeng) {
		static DWORD dwCount = 0;
		if (m_pTvRock) {
			m_pTvRock->ProcessTS(pData, dwLeng);
			dwCount += dwLeng;
			if (dwCount >= 0x100000) {
				RockStatus *pStat = m_pTvRock->GetStatus();
				if (pStat) {
					TVTest::StatusInfo StaInfo;
					m_pApp->GetStatus(&StaInfo);
					pStat->SetStatusSignalLevel(StaInfo.SignalLevel);
					pStat->SetStatusBitrate(StaInfo.BitRate*8);
					pStat->SetStatusErrorPacket(StaInfo.ErrorPacketCount);
					pStat->SetStatusScramblingPacket(StaInfo.ScramblePacketCount);
				}
				dwCount -= 0x100000;
			}
		}
	}
	// Xg[̕ύX
	void StreamChange(const DWORD dwChannel, DWORD dwService) {
		if (m_pTvRock)
			m_pTvRock->OnStreamChange(dwChannel, dwService);
	}
	// `l̎擾
	DWORD GetChannel() {
		return (m_pChannel ? m_pChannel->GetChannel() : 0);
	}
	// T[rX̎擾
	DWORD GetServiceID() {
		int Service = m_pApp->GetService();
		TVTest::ServiceInfo ServiceInfo;
		if (Service<0 || !m_pApp->GetServiceInfo(Service, &ServiceInfo))
			return 0;
		return ServiceInfo.ServiceID;
	}
};

// Cxgʒm
LRESULT CALLBACK CTvRockDTVTarget::EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData)
{
	CTvRockDTVTarget *pThis=static_cast<CTvRockDTVTarget*>(pClientData);
	switch (Event) {
	case TVTest::EVENT_DRIVERCHANGE:
#if 0
		if (pThis->m_DeviceID>=0) {
			WCHAR szDriverName[MAX_PATH];

			szDriverName[0]='\0';
			pThis->m_pApp->GetDriverName(szDriverName,MAX_PATH);
			if (::lstrcmpi(::PathFindFileName(szDriverName),
						   ::PathFindFileName(pThis->m_szDriverName))!=0) {
				pThis->m_pApp->AddLog(L"hCoύXꂽ߁ATvRock DTV TargetI܂B");
				pThis->Finalize();
				return TRUE;
			}
		}
		// Fall through
#endif
	case TVTest::EVENT_CHANNELCHANGE:
		pThis->PurgeStream();
	case TVTest::EVENT_SERVICECHANGE:
	case TVTest::EVENT_SERVICEUPDATE:
		pThis->StreamChange(pThis->GetChannel(), pThis->GetServiceID());
		return TRUE;

	case TVTest::EVENT_EXECUTE:
		{
			LPCWSTR pszCommandLine=reinterpret_cast<LPCWSTR>(lParam1);
			WCHAR szDriverName[MAX_PATH];
			int DeviceID=GetDeviceID(pszCommandLine,szDriverName);
			if (DeviceID>=0
					&& (pThis->m_DeviceID<0 || pThis->m_DeviceID!=DeviceID)) {
				// VfoCXIDݒ
				pThis->Finalize();
				pThis->InitializeTvRockDTV(pszCommandLine);
			} else if (DeviceID<0 && pThis->m_DeviceID>=0
					&& szDriverName[0]!='\0') {
				pThis->Finalize();
			}
		}
		return TRUE;
	}
	return 0;
}

// Xg[̎擾
bool CTvRockDTVTarget::GetStream(BYTE *pBuffer,SIZE_T *pBufferLength)
{
	m_StreamLock.Lock();
	if (m_StreamBufferUsed == 0) {
		m_StreamLock.Unlock();
		return false;
	}
	SIZE_T Size = min(*pBufferLength,m_StreamBufferUsed);
	if (Size > m_StreamBufferLength-m_StreamBufferPos)
		Size = m_StreamBufferLength-m_StreamBufferPos;
	::CopyMemory(pBuffer,m_pStreamBuffer+m_StreamBufferPos*188,Size*188);
	*pBufferLength = Size;
	m_StreamBufferPos += Size;
	if (m_StreamBufferPos == m_StreamBufferLength)
		m_StreamBufferPos = 0;
	m_StreamBufferUsed -= Size;
	m_StreamLock.Unlock();
	return true;
}

// Xg[̔j
void CTvRockDTVTarget::PurgeStream()
{
	if (m_pTvRock!=NULL) {
		m_StreamLock.Lock();
		m_StreamBufferUsed = 0;
		m_StreamBufferPos = 0;
		m_StreamLock.Unlock();
		::ResetEvent(m_hProcessTSEvent);
		::WaitForSingleObject(m_hProcessTSEvent,INFINITE);
	}
}

// Xg[擾Xbh
DWORD WINAPI CTvRockDTVTarget::StreamThread(LPVOID lpParameter)
{
	CTvRockDTVTarget *pThis=static_cast<CTvRockDTVTarget*>(lpParameter);
	BYTE *pBuffer = new BYTE[pThis->m_StreamSendBufferLength*188];
	while (!pThis->m_fStreamEnd) {
		SIZE_T Length = pThis->m_StreamSendBufferLength;
		if (pThis->GetStream(pBuffer,&Length)) {
			pThis->ProcessTS(pBuffer, Length*188);
			::SetEvent(pThis->m_hProcessTSEvent);
		} else {
			::SetEvent(pThis->m_hProcessTSEvent);
			::Sleep(10);
		}
	}
	delete [] pBuffer;
	return 0;
}

// Xg[
BOOL CALLBACK CTvRockDTVTarget::StreamCallback(BYTE *pData,void *pClientData)
{
	CTvRockDTVTarget *pThis = static_cast<CTvRockDTVTarget*>(pClientData);
	pThis->m_StreamLock.Lock();
	if (pThis->m_StreamBufferUsed == pThis->m_StreamBufferLength) {
		pThis->m_DropCount++;
		pThis->m_StreamLock.Unlock();
		return TRUE;
	}
	::CopyMemory(pThis->m_pStreamBuffer+(pThis->m_StreamBufferPos+pThis->m_StreamBufferUsed)%pThis->m_StreamBufferLength*188,pData,188);
	pThis->m_StreamBufferUsed++;
	pThis->m_StreamLock.Unlock();
	return TRUE;
}

// TvRockDTV̏
bool CTvRockDTVTarget::InitializeTvRockDTV(LPCWSTR pszCommandLine)
{
	// TvRock̓foCXʔԍKv
	m_DeviceID = GetDeviceID(pszCommandLine,m_szDriverName);
	if (m_DeviceID < 0) {
		if (m_DeviceID == -2)
			m_pApp->AddLog(L"DIDsłB");
		else
			m_pApp->AddLog(L"DIDw肳Ă܂B");
		return false;
	}

	WCHAR szLog[256];
	::wsprintfW(szLog,L"TvRock DTV Target܂B(DID %c)",m_DeviceID+'A');
	m_pApp->AddLog(szLog);

	// TvRockDTVCu̓ǂݍ
	typedef TvRockDTV *(*CreateTvRockDTV)(HINSTANCE);
	m_hPlug = LoadDTVModule();
	if (m_hPlug==NULL) {
		m_pApp->AddLog(L"TvRockDTVCu܂B");
		Finalize();
		return false;
	}
	CreateTvRockDTV pFunc = (CreateTvRockDTV)GetProcAddress(m_hPlug, "CreateTvRockDTV");
	if (pFunc == NULL) {
		m_pApp->AddLog(L"TvRockDTVCuv܂B");
		Finalize();
		return false;
	}

	// ̃vOC̓foCXł
	// xɕfoCX쐬Ă܂܂
	m_pTvRock = pFunc(m_hPlug);
	if (m_pTvRock == NULL) {
		m_pApp->AddLog(L"TvRockDTV쐬ł܂B");
		Finalize();
		return false;
	}

	// TvRock DTV Target (ɃfoCX݂ꍇG[)
	m_pChannel = new CChannelSearch(m_pApp);
	m_pRequest = new CTvRockRequest(m_pApp, m_pChannel);
	if (!m_pTvRock->Initialize(m_DeviceID,m_pRequest)) {
		m_pApp->AddLog(L"TvRockDTV̏G[łB");
		Finalize();
		return false;
	}

	TCHAR szIniFileName[MAX_PATH],szSectionName[8];
	GetModuleFileName(g_hinstDLL,szIniFileName,MAX_PATH);
	PathRenameExtension(szIniFileName,TEXT(".ini"));
	wsprintf(szSectionName,TEXT("DID_%c"),m_DeviceID+'A');
	m_pChannel->Init(szIniFileName,szSectionName);

	// ݒ̊mF
	RockProperty *pProp = m_pTvRock->GetProperty();
	if (pProp) {
		// ^t@Cgq̒
		WCHAR ext[MAX_PATH];
		memset(ext,0,sizeof(ext));
		pProp->GetFileExtension(ext, MAX_PATH);
		if (wcscmp(ext,_FILE_EXTENSION)) {
			pProp->SetFileExtension(_FILE_EXTENSION);
			pProp->Notify();
		}
		m_pChannel->SetProperty(pProp);
#if 0
		// pXTVTestɍ킹ꍇ
		TCHAR m_szSetting[MAX_PATH];
		TCHAR m_szModFile[MAX_PATH];
		TCHAR m_szModPath[MAX_PATH];
		TCHAR m_szFilePath[MAX_PATH];
		memset(m_szModFile, 0, sizeof(m_szModFile));
		if ( GetModuleFileName(NULL, m_szModFile, MAX_PATH) ) {
			PathRemoveFileSpec(m_szModFile);
			memset(m_szModPath, 0, sizeof(m_szModPath));
			PathCombine(m_szModPath, m_szModFile, _TVTEST_SETTING);
			memset(m_szSetting, 0, sizeof(m_szSetting));
			memset(m_szFilePath, 0, sizeof(m_szFilePath));
			GetPrivateProfileString(TEXT("Settings"), TEXT("RecordFolder"), TEXT("C:\\"), m_szFilePath, MAX_PATH, m_szModPath);
			pProp->GetRecordPath(ext, MAX_PATH);
			if (wcscmp(ext,m_szFilePath)) {
				pProp->SetRecordPath(m_szFilePath);
				pProp->Notify();
			}
		}
#endif
	}

	m_pStreamBuffer = new BYTE[m_StreamBufferLength*188];
	m_StreamBufferUsed = 0;
	m_StreamBufferPos = 0;
	m_hProcessTSEvent = ::CreateEvent(NULL,FALSE,FALSE,NULL);
	m_hStreamThread = ::CreateThread(NULL,0,StreamThread,this,0,NULL);
	m_pApp->SetStreamCallback(0,StreamCallback,this);

	return true;
}


int CTvRockDTVTarget::GetDeviceID(LPCWSTR pszCommandLine,LPWSTR pszDriverName)
{
	pszDriverName[0]='\0';
	if (pszCommandLine == NULL || pszCommandLine[0] == '\0')
		return -1;

	int argc;
	LPWSTR *argv = CommandLineToArgvW(pszCommandLine, &argc);

	if (argv == NULL)
		return -1;
	int DeviceID = -1;
	for (int i=0; i<(argc-1); i++) {
		if (::lstrcmpiW(argv[i], L"/DID")==0) {
			if (argv[i+1][0] >= L'A' && argv[i+1][0] <= L'H') {
				DeviceID = (argv[i+1][0] - L'A');
			} else if (argv[i+1][0] >= L'a' && argv[i+1][0] <= L'h') {
				DeviceID = (argv[i+1][0] - L'a');
			} else {
				DeviceID = -2;
			}
		} else if (::lstrcmpiW(argv[i],L"/d")==0) {
			if (::lstrlenW(argv[i+1])<MAX_PATH)
				::lstrcpyW(pszDriverName,argv[i+1]);
		}
	}
	LocalFree(argv);
	if (DeviceID<0)
		pszDriverName[0]='\0';
	return DeviceID;
}


// vOCEGg
CTVTestPlugin *CreatePluginClass()
{
	return new CTvRockDTVTarget;
}
